#include "IRremote.h"

#define STOP 0
#define FORWARD 1
#define REVERSE 2
#define LEFT 3
#define RIGHT 4

int Movement = 0 ;// 0 - стоим 1 -  вперед 2 - назад 3 - поворот налево, 4 - поворот направо
int LastMovement = 0; // запомнить последнее движение
int Speed=255;
bool Program1 = false ;   // начать автоматическую программу 
int LastTurn = LEFT ;     //  типа последний поворот налево, поворачиваем дальше в противоположную сторону
unsigned long Timer1 = 0 ;          // время горения первого светодиода и потушенности второго   
int Time2 = 0;            // время горения второго 



// цифровые выводы
//int RECV_PIN = 2;
#define RECV_PIN  2

// эхолот
int  echoPin = 3;//10;
int  trigPin = 12;


// левый моторчик
#define HG7881_B_IB 4 // D6 --> Motor B Input B --> MOTOR B -
#define HG7881_B_IA 5 // D7 --> Motor B Input A --> MOTOR B +

// правый моторчик
#define HG7881_A_IA 6 // D5 --> Motor A Input A --> MOTOR B +
#define HG7881_A_IB 7 // D4 --> Motor A Input B --> MOTOR B -

int fara1Pin =10;
int fara2Pin=9;
int motorPin=11;   // ковш

// functional connections
#define MOTOR_B_PWM HG7881_B_IA // Motor B PWM Speed
#define MOTOR_B_DIR HG7881_B_IB // Motor B Direction

// functional connections
#define MOTOR_A_PWM HG7881_A_IA // Motor B PWM Speed
#define MOTOR_A_DIR HG7881_A_IB // Motor B Direction


// the actual values for "fast" and "slow" depend on the motor
#define PWM_SLOW 50  // arbitrary slow speed PWM duty cycle
#define PWM_FAST 200 // arbitrary fast speed PWM duty cycle
#define DIR_DELAY 50 // brief delay for abrupt motor changes
IRrecv irrecv(RECV_PIN); // Указываем пин, к которому подключен приемник
decode_results results;

// аналоговые выводы
int LeftphotoPin  = 0;   // вход левый глаз
int RightphotoPin = 1;  // вход правый глаз фоторезистор подключен 1-му аналоговому входу

int speakerPin = 8;
//int motorPin = 11; // для моторчика
int ledPin = 13;   // инфракнасная поддстветка. светодиод подключается к digital pin 13

int Left1 = 0;       // замер без подсветки
int Left2 = 0;       // замер с подсветкой

int Right1 = 0;       // справа без подсветки
int Right2 = 0;       // справа с подсветкой

int left = 0;       // уровень света фары от 0 до 255
int right = 0;       // уровень света фары от 0 до 255

int grader=0;       // 0 опущен, 1 поднят
bool AutoMovement = false;       // переменная для индикации автоматического движения


int length = 15;                  // число нот
//char notes[] = "ccggaagffeeddc "; // пробел - пауза
//int beats[] = { 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 2, 4 };

char notes[] = "ccggaa"; // пробел - пауза
int beats[] = { 1, 1, 1, 1, 1, 1};


int tempo = 100;
int cm =0;

void setup()
{
pinMode(9, OUTPUT );
pinMode(10, OUTPUT );
pinMode(11, OUTPUT );
digitalWrite( motorPin, LOW );
pinMode( MOTOR_B_DIR, OUTPUT );
pinMode( MOTOR_B_PWM, OUTPUT );
digitalWrite( MOTOR_B_DIR, LOW );
digitalWrite( MOTOR_B_PWM, LOW );
pinMode( MOTOR_A_DIR, OUTPUT );
pinMode( MOTOR_A_PWM, OUTPUT );
digitalWrite( MOTOR_A_DIR, LOW );
digitalWrite( MOTOR_A_PWM, LOW );
pinMode( echoPin, INPUT );
pinMode( trigPin, OUTPUT );
 
  //analogReference(INTERNAL);
  
  Serial.begin(9600); // Выставляем скорость COM порта
  irrecv.enableIRIn(); // Запускаем прием
  pinMode(speakerPin, OUTPUT);

  
  //playNote('d', 0.3 * tempo);   // при старте пищим
 // delay(1000);
  //playNote('c', 0.3 * tempo);
  Melody();
 Timer1=millis()+500;   
  
}
 
void loop() {
  TestDistance();
  if (irrecv.decode(&results)) // Если данные пришли 
  {
    //Serial.println(results.value, HEX); // Отправляем полученную данную в консоль
    Serial.println(results.value); // Отправляем полученную данную в консоль
    
    //Serial.print("         Distance: ");
    //Serial.println(cm);
    //   мотор ковша  
    if (604803425 ==results.value) {
       if (grader ==1){
           GraderDN();
       } else  {
          GraderUP();
       }
    }
    //  уменьшить скорость
    if (0 ==results.value) {
       if (Speed > 0 ) {
           Speed = Speed -10;   //  
       }
    }

    //  программа 1:  включить /выключить
    if (0 ==results.value) {
       Program1 =! Program1 ;   // переключение, один раз включается, второй раз выключается
       if (Program1 == false) {
          //Stop();    // остановить в любом случае
       }
    }
    /*
    //  увеличить скорость
    if (0 ==results.value) {
       if (Speed < 240) {
           Speed = Speed + 10;   //  
       }
    }
    */
    // переключение фары
    if (2724465097 ==results.value) {
        if (left==0){
          left =255;
         analogWrite(fara1Pin, 255 );
        } else {
         left =0;
         analogWrite(fara1Pin, 0 );
          
        }
    }
    // переключение фары
    if (3760167553 ==results.value) {
       if (right==0){
          right =255;
         analogWrite(fara2Pin, 255 );
        } else {
         right =0;
         analogWrite(fara2Pin, 0 );
        }

         
    }



  // оба мотора вперед
    if (1307002951 ==results.value) {
      if (Movement != FORWARD  ) {
       Serial.println("Forward 1307002951");
       Movement = FORWARD;
       Stop();
       Forward(Speed);  

     /* } else {
        Serial.println("stop"); // Отправляем полученную данную в консоль
        Movement = STOP;
        Stop();
      }
      */
      }
    }
    
    // оба мотора назад
   if (193429999 ==results.value) {
      if (Speed>0){
        Serial.println("Reverse");
        Movement = REVERSE;
       Stop();
        Reverse(Speed); 
      }
    }
    // влево, правый вперед, левый назад
    if (3571053223 ==results.value) {
      if (Speed>0){
        Movement = LEFT;
        //Serial.println("Left");
        Stop();
        Left(Speed);
     //  delay(100);   // запускаем моторчик на секунды
        //  

 //     } else {
 //           Stop();
 //           Movement = STOP;
  //          Serial.println("stop");
            
      }
    }
 
    // вправо, правый вперед, левый назад
     if (199473975 ==results.value) {
      if (Speed>0) {
         Serial.println("Right");
         Movement = RIGHT;
         Stop();
         Right(Speed);
       // delay(100);   // запускаем моторчик на секунды
       //Stop();   //  

   //   } else {
   //         Stop();
   //         Movement = STOP;
   //         Serial.println("stop");
      }
    }
    // остановка
    if (1413306296 ==results.value) {
         Serial.println("Stop 1413306296 ");
            Stop();
            Movement = STOP;
      
    }
    // движение
    if (1760049649 ==results.value) {
        
         AutoMovement = ! AutoMovement;
         if (AutoMovement){
            Serial.println("Automovemet start");
            
         } else {
            Serial.println("Automovement stop");
            analogWrite(fara1Pin, 0 );
            analogWrite(fara2Pin, 0 );
            left = 0;
            right =0;
         }
    }
    
  
  

    
  
    
   /* val1 = analogRead(photoPin);    // считываем значение с фототранзистора
    digitalWrite(ledPin, HIGH);
    Serial.print(val1);  
    Serial.print(" >- ");  
    val = analogRead(photoPin);    // считываем значение с фототранзистора
    int val2=val-val1;
    Serial.println(val2);  
    //delay(500);
    digitalWrite(led, LOW);
    */
    //delay(50);
    if (4146609271 ==results.value) {
       playNote('c', 1 * tempo);
    }
    if (1971303647 ==results.value) {
       playNote('d', 1 * tempo);
    }
    if (3007006103 ==results.value) {
       playNote('e', 1 * tempo);
    }
    if (1006888199 ==results.value) {
       playNote('f', 1 * tempo);
    }
    if (3875886367 ==results.value) {
       playNote('g', 1 * tempo);
    }
    if (2762313415 ==results.value) {
       playNote('a', 1 * tempo);
    }
    if (4035547940 ==results.value) {
       playNote('b', 1 * tempo);
    }
    if (3806617471 ==results.value) {
       playNote('C', 1 * tempo);
    }
    
    /*
    // играть мелодию
    if (0 ==results.value) {
      for (int i = 0; i < length; i++) {
        if (notes[i] == ' ') {
        delay(beats[i] * tempo); // пауза
        } else {
         playNote(notes[i], beats[i] * tempo);
        }
     // пауза между нотами
      delay(tempo / 2); 
      }
      
    }
    */
    irrecv.resume(); // Принимаем следующую команду
  }
     // TestDistance();   // всегда проверим на то, что впереди
    //  delay(100);
   // фарки подсветить
   /*
       Serial.print("Distance: ");
         Serial.println(cm);
     if (cm<50 ){
         analogWrite(9, 255-cm*5);
         analogWrite(10,255-cm*5);  
      } else {
         analogWrite(9, 0);
         analogWrite(10,0);  
      }
     */ 
   //  AutoStop();
      TestBack();   // проверить, что там ссзади - это быстро
      if (AutoMovement==true) {    // если программа включена, то проверяем что и как
          Move();
      }
  
}
void Melody()
{
    for (int i = 0; i < length; i++) {
        if (notes[i] == ' ') {
        delay(beats[i] * tempo); // пауза
        } else {
         playNote(notes[i], beats[i] * tempo);
        }
     // пауза между нотами
      delay(tempo / 2); 
      }
  
}

void TestBack()
{
  digitalWrite(ledPin, LOW);   // тушим подсветку в любом случае
   
   Left1 = analogRead(LeftphotoPin);    // считываем значение с фототранзистора
   Right1 = analogRead(RightphotoPin);    // считываем значение с фототранзистора
   
   digitalWrite(ledPin, HIGH);   // включаем подсветку, типа должна сразу включиться
   delay(10);
   Left2 = analogRead(LeftphotoPin);    // считываем значение с фототранзистора
   Right2 = analogRead(RightphotoPin);    // считываем значение с фототранзистора
   digitalWrite(ledPin, LOW);
  /* delay(250);
   Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
     return; 
  */   
  /* 
  Serial.print("L:");
  Serial.print(Left1);
  Serial.print("-");
  Serial.print(Left2);  
  Serial.print(" R:  ");
  Serial.print(Right1);
  Serial.print("-");
  Serial.println(Right2);  
  */
  int val1 = Right2-Right1;  
  int val2 = Left2-Left1;
  
  if (val1 >50 ) {   // если хотя бы один датчик показал, что кто-то близко, то играть мелодию
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
     
      playNote('e', 0.3 * tempo);
  }
    if ( val2>50 ) {   // если хотя бы один датчик показал, что кто-то близко, то играть мелодию
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
      playNote('d', 0.3 * tempo);
  }

  
}


// играет один тон
void playTone(int tone, int duration) {
  for (long i = 0; i < duration * 1000L; i += tone * 2) {
    digitalWrite(speakerPin, HIGH);
    delayMicroseconds(tone);
    digitalWrite(speakerPin, LOW);
    delayMicroseconds(tone);
  }
}
//играет ноту по названию 
void playNote(char note, int duration) {
  char names[] = { 'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C' };
  //int tones[] = { 1915, 1700, 1519, 1432, 1275, 1136, 1014, 956 };
  int tones[] = { 1975, 1760, 1569, 1479, 1318, 1174, 1044, 987 };
  // проиграть тон, соответствующий ноте
 for (int i = 0; i < 8; i++) {
    if (names[i] == note) {
      playTone(tones[i], duration);
    }
  }
}
void AutoStop()
{
     TestBack();
   int val1 = Right2-Right1;  
   int val2 = Left2-Left1;
   
  
  
  if (val1 >50 || val2>50 ) {   // если хотя бы один датчик показал, что кто-то близко, то стоять
      if (Movement == REVERSE){   // задний датчик сработал
          Movement = STOP; // пока препятствие - тормозим 
          LastMovement = STOP;  // остановились полностью
          Stop();
      }
  }
/*
// алгоритмы автоматической остановки
if (cm <=15 && Movement == LEFT ) {   // стоп машина, если едем и мало места пере нами
      Movement = STOP; // пока препятствие - тормозим 
      LastMovement = STOP;  // остановились полностью
      Stop();
}
if (cm <=15 && Movement == RIGHT ) {   // стоп машина, если едем и мало места перед нами
      // голова должна смотреть направо сразу
      Movement = STOP; // пока препятствие - тормозим 
      LastMovement = STOP;  // остановились полностью
      Stop();
}
*/

 TestDistance();

if (cm < 9 && Movement == FORWARD ) {   // стоп машина, если едем и мало места пере нами
  Serial.print(cm);
  Serial.println(" -   Stop move < 9 cm");
      Movement = STOP; // пока препятствие - тормозим 
      LastMovement = FORWARD;
      Stop();
}
  
/*  
  if (cm <10 && Movement == STOP) {   // назад едем, если подносят руку, а мы  стояли
      Stop();
      Reverse(Speed);  
      Movement = REVERSE;
      
  // set the motor speed and direction
  }
  */
  if (cm >9  && Movement == STOP && LastMovement == FORWARD) {   // опять поехали
      //Stop();
      Serial.print(cm);
      Serial.println("   -  Start move > 9 cm");
      Forward(Speed);
      Movement = FORWARD;
  // set the motor speed and direction
  }
  /*
  if (cm >10  && Movement==REVERSE && LastMovement == STOP) {   // останавливаемся, если ехали назад от руки, а ее убрали
      Stop();
      Movement = STOP;
  // set the motor speed and direction
  }
  */
  /*
  if (cm >10  && Movement==REVERSE && LastMovement == FORWARD) {   // препятствий нет, поехали опять вперед
     Stop();
      Forward(Speed);
      Movement = FORWARD;
  // set the motor speed and direction
  */




}



void Stop()
{
     Serial.println("Stop");     
      digitalWrite( MOTOR_A_DIR, LOW );  
      digitalWrite( MOTOR_A_PWM, LOW );
      digitalWrite( MOTOR_B_DIR, LOW );
      digitalWrite( MOTOR_B_PWM, LOW );
      delay( DIR_DELAY );

}
// оба назад
void Reverse(int Speed)
{
    //  Stop();    // сначала остановить
      // set the motor speed and direction
     digitalWrite( MOTOR_A_DIR, LOW ); // direction = reverse
     analogWrite( MOTOR_A_PWM, Speed ); // PWM speed = slow
      // set the motor speed and direction
     digitalWrite( MOTOR_B_DIR, LOW ); // direction = reverse
     analogWrite( MOTOR_B_PWM, Speed); // PWM speed = slow
     Serial.println("Reverse"); 
     AutoStop();    

}

void Forward(int Speed)
{
     // Stop();    // сначала остановить
      // set the motor speed and direction
      // TestDistance();
      /*if (cm<15)
      {
         Serial.print("Distance: ");
         Serial.println(cm);
        playNote('C', tempo);   // если не едем, то пищим
        return;
      }
      */
      Serial.println("Forward");     
      digitalWrite( MOTOR_A_DIR, HIGH ); // direction = forward
      analogWrite( MOTOR_A_PWM, 255-Speed ); // PWM speed = slow
      // set the motor speed and direction
      digitalWrite( MOTOR_B_DIR, HIGH ); // direction = forward
      analogWrite( MOTOR_B_PWM, 255-Speed); // PWM speed = slow
        
}

void TurnLeft(int Speed)   // разворот на месте
{
   //   Stop();    // сначала остановить
   //   TestDistance();
   /*
      if (cm<15)
      {
        return;
      }
     */ 
      Serial.println("TurnLeft");      
      // set the motor speed and direction
      digitalWrite( MOTOR_B_DIR, HIGH ); // direction = forward
      analogWrite( MOTOR_B_PWM, 255-Speed ); // PWM speed = slow
      // set the motor speed and direction
      //digitalWrite( MOTOR_B_DIR, LOW ); // direction = forward
      //analogWrite( MOTOR_B_PWM, LOW ); // direction = forward
     
     digitalWrite( MOTOR_A_DIR, HIGH ); // direction = forward
     
     analogWrite( MOTOR_A_PWM, 255-Speed); // PWM speed = slow
}

void TurnRight(int Speed)   // разворот на месте
{
     // Stop();    // сначала остановить
     // TestDistance();
     /*
      if (cm<15)
      {
        return;
      }
      */
      Serial.println("TurnRight");     
     // digitalWrite( MOTOR_A_DIR, LOW ); // direction = forward
     //analogWrite( MOTOR_A_PWM, LOW );
      analogWrite( MOTOR_B_PWM, Speed ); // PWM speed = slow
     
     analogWrite( MOTOR_B_PWM, LOW );
      
      // set the motor speed and direction
     
      digitalWrite( MOTOR_B_DIR, HIGH ); // direction = forward
      analogWrite( MOTOR_B_PWM, 255-Speed); // PWM speed = slow

}


void Left(int Speed)
{
   //   Stop();    // сначала остановить
   //   TestDistance();
   /*
      if (cm<15)
      {
        return;
      }
     */ 
      Serial.println("Left");      
      // set the motor speed and direction
      //digitalWrite( MOTOR_B_DIR, HIGH ); // direction = forward
      //analogWrite( MOTOR_B_PWM, 255-Speed ); // PWM speed = slow
      // set the motor speed and direction
      digitalWrite( MOTOR_B_DIR, LOW ); // direction = forward
      analogWrite( MOTOR_B_PWM, Speed ); // direction = forward
     
     digitalWrite( MOTOR_A_DIR, HIGH ); // direction = forward
     
     analogWrite( MOTOR_A_PWM, 255-Speed); // PWM speed = slow
}

void Right(int Speed)
{
     // Stop();    // сначала остановить
     // TestDistance();
     /*
      if (cm<15)
      {
        return;
      }
      */
      Serial.println("Right");     
      digitalWrite( MOTOR_A_DIR, LOW ); // direction = forward
     analogWrite( MOTOR_A_PWM, Speed );
     // analogWrite( MOTOR_B_PWM, Speed ); // PWM speed = slow
     
     //analogWrite( MOTOR_B_PWM, LOW );
      
      // set the motor speed and direction
     
      digitalWrite( MOTOR_B_DIR, HIGH ); // direction = forward
      analogWrite( MOTOR_B_PWM, 255-Speed); // PWM speed = slow

}

void TestDistance()
{
  int duration;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin,HIGH);   // таймаут в микросекундах
  cm = duration / 58;     // здесь записывается в глобальную переменную
 // Serial.print("cm ");
 // Serial.println(cm);
}

void GraderUP()   // подъем ковша
{
Serial.println("GraderUP");

  // ковш закрывает обзор дальномеру, пока закрывает, поднимаем
TestDistance();   
 if (cm==0){
    TestDistance();   
 }
 Serial.print("Distance: ");
 Serial.println(cm);
 if (cm!=0 && cm < 5){
     digitalWrite( motorPin, HIGH );
     int timer = micros()+2000;   // через секунду в любом случае выпадаем   
     while (cm==0  || cm < 5 ) {    // но, нужно прекратить когда-нибудь
         TestDistance();
         Serial.print("Distance: ");
         Serial.println(cm);
         
         delayMicroseconds(10);
         if (timer>micros()){
             break;
          
         }
        if (cm==0){
           continue;
         }

     }
     
     digitalWrite( motorPin, LOW);
   //  проверить, если поднят, то хорошо
 }
     TestDistance();   
     if (cm==0){
        TestDistance();   
     }
     if (cm > 5){   
          grader=1;   // когда подняли
     }
     
 
 
}
void GraderDN()   // опускание
{
 Serial.println("GraderDN");
 
  // ковш закрывает обзор дальномеру, пока закрывает, крутим
 TestDistance();   
 if (cm==0){
    TestDistance();   
 }
 Serial.print("Distance: ");
 Serial.println(cm);
 if (cm!=0 && cm > 5){
     digitalWrite( motorPin, HIGH);
     int timer = micros()+1000;   // через секунду в любом случае выпадаем   
     while (cm==0 || cm > 5 ) {    // но, нужно прекратить когда-нибудь
         TestDistance();
          Serial.print("Distance: ");
         Serial.println(cm);
         delayMicroseconds(10);
         
          if (timer>micros()){
             break;
          
         }
         if (cm==0){
           continue;
         }
     }
    
    digitalWrite( motorPin, LOW);
 }
    TestDistance();   
    if (cm==0){
        TestDistance();   
    }
    
    if (cm < 5){
          Serial.println("grader=0");   
          grader=0;   // точно опустили
    }

    
 
 
}

void Move()
{
/*

1. НАчало. Проверить дальность, если меньше трёх, то включить ковш. Проверять до тех пор, пока дальность не станет больше 3 сантиметров. 0 не учитывать.
2. Начать движение вперёд.
3. Измеряем расстояние до препятствия впереди.
4. Если это измеренное расстояние меньше значения DST_TRH_BACK (сокращение от distance threshold),  останавливаемся и едем задним ходом одновременно поворачивая. Направление поворота выбираем так: если ранее уже поворачивали влево, то поворачиваем вправо и наоборот.
5. Если измеренное расстояние больше чем DST_TRH_BACK, но меньше чем DST_TRH_TURN, то просто поворачиваем. Направление поворота выбираем случайно.
6. Если до препятствия далеко, то просто едем вперед.
7. Повторяем все сначала.
*/
TestBack(); 
   unsigned long mil = millis();
   if (Timer1 < mil){   // время переключить фарки
       if (left==0){
             left =255;
             right = 0;
        } else {
              left =0;
              right = 255;
        }
        analogWrite(fara1Pin, left );
        analogWrite(fara2Pin, right ); 
        Timer1 = mil+500;
   }
   
   
   if (grader==0){
       GraderUP();  // подняли ковш в при автоматическом движении всегда
   }
    int LightLevel=370;
     int val1 = 0;  
    int val2 = 0;
   switch (Movement) {
    case FORWARD:
        TestDistance();
         if (cm==0){
            TestDistance();    // еще раз на всякий случай
          }
    
    if (cm >= 10) {
        // продолжаем ехать
         Forward(Speed);
         break;
      }
      if (cm < 10 && cm !=0) {   // там, меньше 15 автостоп стоит, здесь поворачиваем
          Stop();
          Reverse(Speed);   // назад чуть отъедем   по времени все делаем
          delay(1000);  
          if (LastTurn==LEFT){
               Stop();
               Right(Speed);
               LastTurn=RIGHT;
               
          } else {      
              Stop();
              Left(Speed);
              LastTurn=LEFT;
          }
          delay(1000);  
          }
      Stop();    
      Movement = FORWARD;
      Forward(Speed);     // поедем дальше
      break;
    case LEFT:
    //  Left(Speed);
      break;
    case RIGHT:
    //   Right(Speed);
       break;
    case REVERSE:

      TestBack(); 
      val1 = Right2-Right1;  
      val2 = Left2-Left1;
  
    if (val1 >30 || val2>30  ) {   // оба датчика показали
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
      Stop();
      Forward(Speed);
      delay(1000);  
       if (LastTurn==LEFT){
               Stop();
               Right(Speed);
               LastTurn=RIGHT;
               
          } else {      
              Stop();
              Left(Speed);
              LastTurn=LEFT;
          }
          delay(1000);  
      
      Stop();    
      Reverse(Speed);     // поедем дальше
      }
      break;
   
      case STOP:


    
      // стоим, то от руки отбегать
      TestBack(); 
      val1 = Right2-Right1;  
      val2 = Left2-Left1;
  
    if (val1 >30 && val2>30  ) {   // оба датчика показали
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
      Forward(Speed);
      delay(300);  
      Stop(); 
     
    }
    if ( val2>30 && val1<30 ) {   // один датчик
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
      Right(Speed);
      delay(300);
      Stop(); 
      
    }
    if ( val1>30 && val2<30 ) {   // один датчик
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print("-");
      Serial.print(Left2);  
      Serial.print(" R:  ");
      Serial.print(Right1);
      Serial.print("-");
      Serial.println(Right2); 
      Left(Speed);
      delay(300);  
      Stop();
      
    }
// погоня за светом
   
    if (Left1 >LightLevel && Right1>LightLevel  ) {   // оба датчика засвечены
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print(" R:  ");
      Serial.print(Right1);
      Reverse(Speed);
      delay(300);  
       Stop();
     break;
    }
    if (Left1 >LightLevel && Right1<LightLevel ) {   // только один
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print(" R:  ");
      Serial.print(Right1);
      TurnLeft(Speed);
      delay(300);  
       Stop();
     break;
    }
    if (Right1 > LightLevel && Left1 < LightLevel ) {   // только один
      Serial.print("L:");
      Serial.print(Left1);
      Serial.print(" R:  ");
      Serial.print(Right1);
      TurnRight(Speed);
      delay(300);  
       Stop();
     break;
    }

      
    default:
    // пока не едем, то самое интересное
      
      break;
       
  }
    
   
   
  
   
   
   
   


 
return;
  

}




